
.486
.model flat, stdcall
option casemap: none


include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc


includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib


DialogProc PROTO : HWND,  : UINT, : WPARAM, : LPARAM

DrawItem   PROTO : HWND,  : LPARAM


.const

; Resource ids
IDC_EXIT     equ 404


; Colors
CR_BACKGROUND equ 0h
CR_FOREGROUND equ 00C0C0C0h
CR_HIGHLIGHT  equ 00C0C0C0h

CR_INPUT      equ 0h
CR_INPUT2      equ 00FFFFFFh


.data?

hInstance  HINSTANCE ?

; Brushes & pens
hBgColor   HBRUSH    ?
hFgColor   HBRUSH    ?
hInColor   HBRUSH    ?
hIn2Color  HBRUSH    ?
hEdge      HPEN      ?
hEdge2     HPEN      ?
; Font & text
BoldFont   LOGFONT   <?>
sBtnText   TCHAR     16 dup(?)



.code

start:

INVOKE GetModuleHandle, NULL
mov hInstance, eax

; Create brushes for custom colors
INVOKE CreateSolidBrush, CR_BACKGROUND
mov hBgColor, eax

INVOKE CreateSolidBrush, CR_INPUT
mov hInColor, eax

INVOKE CreatePen, PS_INSIDEFRAME, 1, CR_FOREGROUND
mov hEdge, eax
INVOKE CreatePen, PS_INSIDEFRAME, 1, CR_INPUT2 
mov hEdge2, eax

; Show the dialog box
INVOKE DialogBoxParam, hInstance, 100, NULL, ADDR DialogProc, 0

; Restore the memory used for graphic objects
INVOKE DeleteObject, hEdge
INVOKE DeleteObject, hInColor
INVOKE DeleteObject, hIn2Color
INVOKE DeleteObject, hFgColor
INVOKE DeleteObject, hBgColor

; Exit the program
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc PROC hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

  .IF uMsg == WM_INITDIALOG
  
  
  .ELSEIF uMsg == WM_CTLCOLORDLG
    mov eax, hBgColor
    ret
  
  .ELSEIF uMsg == WM_DRAWITEM
    INVOKE DrawItem, hWnd, lParam
 
  .ELSEIF uMsg == WM_COMMAND


    .IF wParam ==  IDC_EXIT
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
 
    .ENDIF
  
  .ELSEIF uMsg == WM_CLOSE
         INVOKE EndDialog, hWnd, 0
  .ENDIF

  xor eax, eax
  ret
DialogProc ENDP


DrawItem PROC hWnd: HWND, lParam: LPARAM
  push esi
  mov esi, lParam
  assume esi: ptr DRAWITEMSTRUCT

;buttons color
    INVOKE SelectObject, [esi].hdc, hInColor


;frame color
.IF [esi].itemState & ODS_SELECTED
   INVOKE SelectObject, [esi].hdc, hEdge2
  .ELSE
    INVOKE SelectObject, [esi].hdc, hEdge
  .ENDIF


  INVOKE FillRect, [esi].hdc, ADDR [esi].rcItem, hBgColor
  INVOKE RoundRect, [esi].hdc, [esi].rcItem.left, [esi].rcItem.top, [esi].rcItem.right, [esi].rcItem.bottom, 6, 6

  .IF [esi].itemState & ODS_SELECTED
    INVOKE OffsetRect, ADDR [esi].rcItem, 1, 1
  .ENDIF

  ; Write the text
  INVOKE GetDlgItemText, hWnd, [esi].CtlID, ADDR sBtnText, SIZEOF sBtnText
  INVOKE SetBkMode, [esi].hdc, TRANSPARENT


;textcolor
  .IF [esi].itemState & ODS_SELECTED
      INVOKE SetTextColor, [esi].hdc, CR_INPUT2
  .ELSE
      INVOKE SetTextColor, [esi].hdc, CR_HIGHLIGHT
  .ENDIF

  INVOKE DrawText, [esi].hdc, ADDR sBtnText, -1, ADDR [esi].rcItem, DT_CENTER or DT_VCENTER or DT_SINGLELINE

  .IF [esi].itemState & ODS_SELECTED
    INVOKE OffsetRect, ADDR [esi].rcItem, -1, -1
  .ENDIF

  ; Draw the focus rectangle
  .IF [esi].itemState & ODS_FOCUS
    INVOKE InflateRect, ADDR [esi].rcItem, -3, -3
    ;INVOKE DrawFocusRect, [esi].hdc, ADDR [esi].rcItem
  .ENDIF

  assume esi:nothing
  pop esi
  mov eax, TRUE
  ret
DrawItem ENDP

;
END start